SystemOrganization addCategory: #PruebaPablo!

Trait named: #Analogico
	uses: {}
	category: 'PruebaPablo'!

!Analogico commentStamp: '<historical>' prior: 0!
Un Analogico es un Trait que guarda los mtodos correspondientes a las tecnologas analgicas.

Las clases CRT, LCD y LED utilizan este TRAIT.!

!Analogico methodsFor: 'as yet unclassified' stamp: 'Pablo 3/29/2013 18:13'!
tuDefinicionMaxima: aparato
	"Devuelve la definicin mxima de un dispositivo con tecnologa analgica. "

	^480! !

Trait named: #Digital
	uses: {}
	category: 'PruebaPablo'!

!Digital commentStamp: '<historical>' prior: 0!
Un Digital es un Trait que guarda los mtodos correspondientes a las tecnologas digitales.

Las clases CRT, LCD y LED utilizan este TRAIT.!

!Digital methodsFor: 'as yet unclassified' stamp: 'Pablo 4/6/2013 15:56'!
tuDefinicionMaxima: aparato
	"Devuelve la definicin mxima de un dispositivo con tecnologa digital. "

	^( aparato ppp *  ( ( ( aparato  tamanio  ) raisedTo: 2 )  / 2 )  sqrt )! !

Trait named: #FabricaDePantallas
	uses: {}
	category: 'PruebaPablo'!

!FabricaDePantallas commentStamp: '<historical>' prior: 0!
Una FabricaDePantallas es un Trait donde se guardan los metodos para la fabricacin de Pantallas.

Las clases CRT, LCD y LED utilizan este TRAIT
!

!FabricaDePantallas methodsFor: 'as yet unclassified' stamp: 'Pablo 4/6/2013 15:57'!
fabricarMonitor
	"Instancia un objeto de la clase Monitor"

	| nuevoMonitor |
	nuevoMonitor  := Monitors new .
	nuevoMonitor tecnologia:  self.
	^nuevoMonitor .! !

!FabricaDePantallas methodsFor: 'as yet unclassified' stamp: 'Pablo 4/6/2013 15:57'!
fabricarSmartTV
	"Instancia un objeto de la clase SmartTV"

	| nuevaSmartTV |
	nuevaSmartTV  := SmartTV new .
	nuevaSmartTV  tecnologia: self.
	^nuevaSmartTV .! !

!FabricaDePantallas methodsFor: 'as yet unclassified' stamp: 'Pablo 4/6/2013 15:57'!
fabricarTV
	"Instancia un objeto de la clase TV"

	| nuevaTV |
	nuevaTV  := TV new .
	nuevaTV  tecnologia: self.
	^nuevaTV .! !

Trait named: #Pantalla
	uses: {}
	category: 'PruebaPablo'!

!Pantalla commentStamp: '<historical>' prior: 0!
A Pantalla es un trait.
!

!Pantalla methodsFor: 'as yet unclassified' stamp: 'jmd 4/8/2013 15:02'!
cableConectado 
	^self entradas detect: [ :unaEntrada | unaEntrada tenesUnCableConectado] ifNone:[nil]! !

!Pantalla methodsFor: 'as yet unclassified' stamp: 'Pablo 4/6/2013 15:57'!
conectarEntrada: posicEntrada conCable: unCable
	"Conecta la entrada de la posicin deseada. Para esto primero desconecta todas las demas entradas."

	self desconectarEntradas: self entradas .
	( self entradas  at: posicEntrada ) conectar: unCable .

	! !

!Pantalla methodsFor: 'as yet unclassified' stamp: 'Pablo 4/6/2013 22:03'!
consumoEntrada
	"Calculo el consumo adicional de la entrada que este en uso"

	| entrada |
	
	entrada := self entradas detect: [ :unaEntrada | unaEntrada tenesUnCableConectado] ifNone:[nil] .
	entrada isNil  ifTrue: [^0] ifFalse: [^entrada tuConsumo: self]  
	! !

!Pantalla methodsFor: 'as yet unclassified' stamp: 'Braian 4/14/2013 00:49'!
cualEsTuTamanio 

	self requirement.! !

!Pantalla methodsFor: 'as yet unclassified' stamp: 'Pablo 4/6/2013 13:49'!
cualesSonTusPPP 
	"Devuelve PPP"

	self requirement! !

!Pantalla methodsFor: 'as yet unclassified' stamp: 'Pablo 4/6/2013 13:40'!
desconectarEntradas: todasLasEntradas 
	"Desutiliza todas las entradas que posee el aparato. Recordar que solo se puede utilizar una a la vez"

	todasLasEntradas do:[ :unaEntrada | unaEntrada desconectate ]! !

!Pantalla methodsFor: 'as yet unclassified' stamp: 'jmd 4/8/2013 14:54'!
sePuedeConectar: unCable
	
	^(unCable definicion <= self tuDefinicionMaxima )! !

!Pantalla methodsFor: 'as yet unclassified' stamp: 'jmd 4/8/2013 14:55'!
sosBuenaParaJuegos

	^self tuRefrescoReal >100! !

!Pantalla methodsFor: 'as yet unclassified' stamp: 'Pablo 4/6/2013 16:00'!
teAgregoEntrada: unaClaseEntrada
	"Agrega una entrada a la pantalla"
	
	| unaEntrada |
	unaEntrada := unaClaseEntrada  new.
	self entradas  add: unaEntrada .! !

!Pantalla methodsFor: 'as yet unclassified' stamp: 'Pablo 4/6/2013 22:20'!
tuConsumo
	"Devuelve el consumo de la pantalla"

	^( ( self tecnologia  tuConsumo: self tamanio  )+ self consumoEntrada ).! !

!Pantalla methodsFor: 'as yet unclassified' stamp: 'Braian 4/14/2013 00:58'!
tuDefinicionMaxima 
	"Devuelve la definicin mxima de la pantalla en cuestin."

	^self tecnologia tuDefinicionMaxima: self! !

!Pantalla methodsFor: 'as yet unclassified' stamp: 'Pablo 4/9/2013 21:26'!
tuRefrescoReal
		
	^self tuRefresco min: (self cableConectado tuRefresco)! !

!Pantalla methodsFor: 'as yet unclassified' stamp: 'Braian 4/14/2013 01:06'!
tuResolucionMaxima
	
	^((((self cualesSonTusPPP * self cualEsTuTamanio) raisedTo: 2) - ((self tuDefinicionMaxima) raisedTo: 2)) sqrt) * self tuDefinicionMaxima.  
	
	! !

Object subclass: #Cable
	instanceVariableNames: 'definicion refresco'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PruebaPablo'!

!Cable commentStamp: '<historical>' prior: 0!
Cable es una clase abstracta.

Instance Variables
!

!Cable methodsFor: 'accessing' stamp: 'Pablo 4/6/2013 17:39'!
definicion
	^ definicion! !

!Cable methodsFor: 'accessing' stamp: 'Pablo 4/6/2013 17:39'!
definicion: anObject
	definicion := anObject! !

!Cable methodsFor: 'accessing' stamp: 'jmd 4/8/2013 14:25'!
refresco
	^ refresco! !

!Cable methodsFor: 'accessing' stamp: 'jmd 4/8/2013 14:25'!
refresco: anObject
	refresco := anObject! !

Object subclass: #Componente
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PruebaPablo'!

!Componente methodsFor: 'as yet unclassified' stamp: 'Brimbo 4/6/2013 16:25'!
consumo
	self subclassResponsibility ! !

Componente subclass: #DiscoMagnetico
	instanceVariableNames: 'rpm'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PruebaPablo'!

!DiscoMagnetico class methodsFor: 'as yet unclassified' stamp: 'Brimbo 4/6/2013 20:24'!
new: revoluciones
	|instancia|
	instancia := super new.
	instancia rpm: revoluciones.
	^instancia.! !

!DiscoMagnetico methodsFor: 'as yet unclassified' stamp: 'Brimbo 4/6/2013 16:33'!
consumo
	^self rpm * 60 / 10000! !

!DiscoMagnetico methodsFor: 'accessing' stamp: 'Brimbo 4/6/2013 18:04'!
rpm
	^ rpm! !

!DiscoMagnetico methodsFor: 'accessing' stamp: 'Brimbo 4/6/2013 18:04'!
rpm: anObject
	rpm := anObject! !

Componente subclass: #DiscoSolido
	instanceVariableNames: 'consumoEspecifico'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PruebaPablo'!

!DiscoSolido class methodsFor: 'as yet unclassified' stamp: 'Brimbo 4/6/2013 20:24'!
new: unConsumo 
	|instancia|
	instancia := super new.
	instancia consumoEspecifico: unConsumo.
	^instancia.! !

!DiscoSolido methodsFor: 'as yet unclassified' stamp: 'Brimbo 4/6/2013 17:26'!
consumo 
	^self consumoEspecifico! !

!DiscoSolido methodsFor: 'accessing' stamp: 'Brimbo 4/6/2013 18:05'!
consumoEspecifico
	^ consumoEspecifico! !

!DiscoSolido methodsFor: 'accessing' stamp: 'Brimbo 4/6/2013 18:05'!
consumoEspecifico: anObject
	consumoEspecifico := anObject! !

Componente subclass: #PlacaDeVideo
	instanceVariableNames: 'cantidadDeCoolers'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PruebaPablo'!

PlacaDeVideo subclass: #Comun
	instanceVariableNames: 'consumoPromedio resolucion'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PruebaPablo'!

!Comun class methodsFor: 'as yet unclassified' stamp: 'Brimbo 4/6/2013 20:22'!
new: unConsumo y: cantCoolers 
	|instancia|
	instancia := super new: cantCoolers.
	instancia consumoPromedio: unConsumo.
	^instancia.! !

!Comun methodsFor: 'accessing' stamp: 'Brimbo 4/6/2013 17:28'!
consumoPromedio: anObject
	consumoPromedio := anObject! !

!Comun methodsFor: 'as yet unclassified' stamp: 'Brimba 4/7/2013 03:28'!
consumoPropio 
	^consumoPromedio! !

!Comun methodsFor: 'accessing' stamp: 'Braian 4/13/2013 17:21'!
criterioDeAptitud
	^(self resolucion ln / self consumoPropio) <= 4.
	! !

!Comun methodsFor: 'accessing' stamp: 'Braian 4/13/2013 16:21'!
resolucion
	^ resolucion! !

!Comun methodsFor: 'accessing' stamp: 'Braian 4/13/2013 16:21'!
resolucion: anObject
	resolucion := anObject! !

PlacaDeVideo subclass: #Gpu
	instanceVariableNames: 'anchoMax largoMax pantalla'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PruebaPablo'!

!Gpu class methodsFor: 'as yet unclassified' stamp: 'Brimbo 4/6/2013 20:21'!
new:  unAnchoMax y: unLargoMax y: unaPantalla y: cantCoolers
	|instancia|
	instancia := super new: cantCoolers.
	instancia anchoMax:  unAnchoMax.
	instancia largoMax: unLargoMax.
	instancia pantalla: unaPantalla.
	^instancia.	! !

!Gpu methodsFor: 'accessing' stamp: 'Brimbo 4/6/2013 17:28'!
anchoMax
	^ anchoMax! !

!Gpu methodsFor: 'accessing' stamp: 'Brimbo 4/6/2013 17:28'!
anchoMax: anObject
	anchoMax := anObject! !

!Gpu methodsFor: 'as yet unclassified' stamp: 'Brimbo 4/6/2013 16:48'!
consumoPropio 
	^(self resolucion) * (1/100000)! !

!Gpu methodsFor: 'as yet unclassified' stamp: 'Brimba 4/7/2013 03:22'!
criterioDeAptitud
	^true.! !

!Gpu methodsFor: 'accessing' stamp: 'Brimbo 4/6/2013 17:29'!
largoMax
	^ largoMax! !

!Gpu methodsFor: 'accessing' stamp: 'Brimbo 4/6/2013 17:29'!
largoMax: anObject
	largoMax := anObject! !

!Gpu methodsFor: 'accessing' stamp: 'Brimbo 4/6/2013 17:29'!
pantalla
	^ pantalla! !

!Gpu methodsFor: 'accessing' stamp: 'Brimbo 4/6/2013 17:29'!
pantalla: anObject
	pantalla := anObject! !

!Gpu methodsFor: 'as yet unclassified' stamp: 'Braian 4/14/2013 01:09'!
resolucion 
	^self resolucionMaxima min: self pantalla tuResolucionMaxima.! !

!Gpu methodsFor: 'as yet unclassified' stamp: 'Brimbo 4/6/2013 16:47'!
resolucionMaxima
	^self anchoMax * self largoMax! !

PlacaDeVideo subclass: #OnBoard
	instanceVariableNames: 'consumoEspecifico'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PruebaPablo'!

!OnBoard class methodsFor: 'as yet unclassified' stamp: 'Edu 4/14/2013 17:31'!
new: unConsumo y: cantCoolers 
	|instancia|
	instancia := super new: cantCoolers.
	instancia consumoEspecifico: unConsumo.
	^instancia.! !

!OnBoard methodsFor: 'accessing' stamp: 'Edu 4/13/2013 19:45'!
consumoEspecifico: anObject
	consumoEspecifico := anObject! !

!OnBoard methodsFor: 'as yet unclassified' stamp: 'Edu 4/13/2013 19:44'!
consumoPropio 
	^consumoEspecifico! !

!OnBoard methodsFor: 'as yet unclassified' stamp: 'Brimba 4/7/2013 03:23'!
criterioDeAptitud 
	^false.! !

!PlacaDeVideo class methodsFor: 'as yet unclassified' stamp: 'Brimbo 4/6/2013 20:23'!
new: cantCoolers
	|instancia|
	instancia := super new.
	instancia cantidadDeCoolers: cantCoolers.
	^instancia.! !

!PlacaDeVideo methodsFor: 'accessing' stamp: 'Brimbo 4/6/2013 17:27'!
cantidadDeCoolers
	^ cantidadDeCoolers! !

!PlacaDeVideo methodsFor: 'accessing' stamp: 'Brimbo 4/6/2013 17:27'!
cantidadDeCoolers: anObject
	cantidadDeCoolers := anObject! !

!PlacaDeVideo methodsFor: 'as yet unclassified' stamp: 'Brimbo 4/6/2013 16:42'!
consumo
	^self consumoPropio + self consumoCoolers! !

!PlacaDeVideo methodsFor: 'as yet unclassified' stamp: 'Brimba 4/7/2013 00:42'!
consumoCoolers 
	^cantidadDeCoolers * 0.5! !

!PlacaDeVideo methodsFor: 'accessing' stamp: 'Edu 4/13/2013 19:07'!
consumoPropio
	self subclassResponsibility ! !

!PlacaDeVideo methodsFor: 'as yet unclassified' stamp: 'Brimba 4/7/2013 03:20'!
criterioDeAptitud 
	self subclassResponsibility.! !

Object subclass: #Computadora
	instanceVariableNames: 'componentes placaDeVideo'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PruebaPablo'!

!Computadora class methodsFor: 'as yet unclassified' stamp: 'Brimbo 4/6/2013 20:23'!
new
	 |unaInstancia|
	unaInstancia := super new.
	unaInstancia componentes: Bag new.
	^unaInstancia.! !

!Computadora methodsFor: 'as yet unclassified' stamp: 'Brimbo 4/6/2013 17:30'!
agregarComponente: unComponente 
	componentes add: unComponente! !

!Computadora methodsFor: 'accessing' stamp: 'Brimba 4/7/2013 03:19'!
aptaParaVideoJuegos
	^self placaDeVideo criterioDeAptitud! !

!Computadora methodsFor: 'accessing' stamp: 'Brimbo 4/6/2013 20:27'!
componentes
	^ componentes! !

!Computadora methodsFor: 'accessing' stamp: 'Brimbo 4/6/2013 20:27'!
componentes: anObject
	componentes := anObject! !

!Computadora methodsFor: 'as yet unclassified' stamp: 'Edu 4/14/2013 18:33'!
consumoTotal
	self componentes ifEmpty: [^0] ifNotEmpty: [^componentes sum: [:unComponente | unComponente consumo]].! !

!Computadora methodsFor: 'accessing' stamp: 'Brimba 4/7/2013 03:07'!
placaDeVideo
	^placaDeVideo.! !

!Computadora methodsFor: 'accessing' stamp: 'Brimba 4/7/2013 03:08'!
placaDeVideo: unaPlacaDeVideo
	placaDeVideo := unaPlacaDeVideo.
	componentes add: unaPlacaDeVideo.! !

Object subclass: #Entrada
	instanceVariableNames: 'cable'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PruebaPablo'!

!Entrada commentStamp: '<historical>' prior: 0!
Una Entrada es una clase abstracta.

Instance Variables
	cable:		<Object>

cable
	- xxxxx
!

Entrada subclass: #AudioVideo
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PruebaPablo'!

!AudioVideo methodsFor: 'as yet unclassified' stamp: 'Pablo 4/6/2013 18:12'!
tuConsumo: unaPantalla

	^ ( unaPantalla tecnologia tuConsumo: unaPantalla tamanio ) * 0.10! !

!AudioVideo methodsFor: 'as yet unclassified' stamp: 'jmd 4/8/2013 14:34'!
tuRefresco

	^50 ! !

!Entrada methodsFor: 'accessing' stamp: 'jmd 4/8/2013 14:32'!
cable
	^ cable! !

!Entrada methodsFor: 'as yet unclassified' stamp: 'Pablo 3/29/2013 21:32'!
conectar: unCable
	"Conecta el cable a esta entrada"

	cable := unCable ! !

!Entrada methodsFor: 'as yet unclassified' stamp: 'jmd 4/8/2013 15:05'!
desconectate
	"Desconecta el cable de sta entrada"

	cable := nil.! !

!Entrada methodsFor: 'as yet unclassified' stamp: 'Pablo 4/2/2013 01:39'!
tenesUnCableConectado
	"Devuelve si la entrada tiene un cable conectado o no."
	
	^( cable isNil ) not 
	
	! !

Entrada subclass: #HDMI
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PruebaPablo'!

!HDMI methodsFor: 'as yet unclassified' stamp: 'Pablo 4/6/2013 18:11'!
tuConsumo: unaPantalla

	^ ( unaPantalla tecnologia tuConsumo: unaPantalla tamanio ) * 0.20! !

!HDMI methodsFor: 'as yet unclassified' stamp: 'jmd 4/8/2013 14:33'!
tuRefresco

	^self cable refresco! !

Entrada subclass: #RF
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PruebaPablo'!

!RF methodsFor: 'as yet unclassified' stamp: 'Pablo 4/6/2013 18:12'!
tuConsumo: unaPantalla 
	
	^0! !

!RF methodsFor: 'as yet unclassified' stamp: 'jmd 4/8/2013 14:33'!
tuRefresco
	
	^50! !

Entrada subclass: #VGAcable
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PruebaPablo'!

!VGAcable methodsFor: 'as yet unclassified' stamp: 'Pablo 4/6/2013 22:16'!
tuConsumo: unaPantalla
	
	^0.001 * cable definicion ! !

!VGAcable methodsFor: 'as yet unclassified' stamp: 'jmd 4/8/2013 14:33'!
tuRefresco
	
	^120! !

Object subclass: #Producto
	uses: Pantalla - {#cualesSonTusPPP}
	instanceVariableNames: 'tecnologia tamanio ppp entradas'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PruebaPablo'!

!Producto commentStamp: '<historical>' prior: 0!
Una Pantalla es una clase abstracta.

Instance Variables
	entradas:		<Object>
	ppp:		<Object>
	tamanio:		<Object>
	tecnologia:		<Object>

entradas
	-Colleccin de entradas.

ppp
	- xxxxx

tamanio
	- Tamao de la pantalla

tecnologia
	- Referencia a uno de los 3 objetos Tecnologa.
!

Producto class
	uses: Pantalla classTrait
	instanceVariableNames: ''!

Producto subclass: #Monitors
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PruebaPablo'!

!Monitors class methodsFor: 'as yet unclassified' stamp: 'Pablo 4/6/2013 16:05'!
teFabricoConTecnologia: unaTecnologia conTamanio: unTamanio conPPP:unPPP
	"Crea un objeto de la clase Monitors" 

	| pantalla |
	pantalla := unaTecnologia  fabricarMonitor.
	pantalla inicializarConTamanio: unTamanio conPPP: unPPP .
	^pantalla! !

!Monitors methodsFor: 'as yet unclassified' stamp: 'Pablo 3/29/2013 19:15'!
tuRefresco
	"Devuelve la tasa de refresco del monitor"
	
	^120! !

!Producto methodsFor: 'as yet unclassified' stamp: 'jmd 4/8/2013 15:26'!
consumoEntrada
	"Calculo el consumo adicional de la entrada que este en uso"

	| entrada |
	
	entrada := self cableConectado .
	entrada isNil  ifTrue: [^0] ifFalse: [^entrada tuConsumo: self]  
	! !

!Producto methodsFor: 'as yet unclassified' stamp: 'Braian 4/14/2013 00:50'!
cualEsTuTamanio 

	^tamanio.! !

!Producto methodsFor: 'accessing' stamp: 'Braian 4/14/2013 00:52'!
cualesSonTusPPP
	^ ppp! !

!Producto methodsFor: 'accessing' stamp: 'Braian 4/14/2013 00:54'!
cualesSonTusPPP: anObject
	ppp := anObject! !

!Producto methodsFor: 'accessing' stamp: 'Pablo 4/6/2013 15:56'!
entradas
	^ entradas! !

!Producto methodsFor: 'accessing' stamp: 'Pablo 4/6/2013 15:56'!
entradas: anObject
	entradas := anObject! !

!Producto methodsFor: 'as yet unclassified' stamp: 'Braian 4/14/2013 00:54'!
inicializarConTamanio: unTamanio conPPP: unPPP .
	"Inicializa variables de instancia de la clase Pantalla"

	self tamanio: unTamanio .
	self entradas: OrderedCollection  new.
	self cualesSonTusPPP: unPPP.! !

!Producto methodsFor: 'accessing' stamp: 'Pablo 4/6/2013 15:56'!
tamanio
	^ tamanio! !

!Producto methodsFor: 'accessing' stamp: 'Pablo 4/6/2013 15:56'!
tamanio: anObject
	tamanio := anObject! !

!Producto methodsFor: 'as yet unclassified' stamp: 'Pablo 4/7/2013 02:30'!
teAgregoEntrada: unaClaseEntrada
	"Agrega una entrada a la pantalla"
	
	| unaEntrada |
	unaEntrada := unaClaseEntrada  new.
	self entradas add: unaEntrada .! !

!Producto methodsFor: 'accessing' stamp: 'Pablo 4/6/2013 15:56'!
tecnologia
	^ tecnologia! !

!Producto methodsFor: 'accessing' stamp: 'Pablo 4/6/2013 15:56'!
tecnologia: anObject
	tecnologia := anObject! !

!Producto methodsFor: 'as yet unclassified' stamp: 'Pablo 3/29/2013 21:27'!
tuRefresco
	"Devuelve la tasa de refresco de la pantalla"
	
	^self subclassResponsibility ! !

Producto subclass: #SmartTV
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PruebaPablo'!

!SmartTV class methodsFor: 'as yet unclassified' stamp: 'Pablo 4/6/2013 16:11'!
teFabricoConTecnologia: tecnologiaLED conTamanio: unTamanio conPPP:unPPP
	"Crea un objeto de la clase SmartTV " 

	| pantalla |
	pantalla := tecnologiaLED fabricarSmartTV .
      pantalla inicializarConTamanio: unTamanio  conPPP: unPPP .
	^pantalla
! !

!SmartTV methodsFor: 'as yet unclassified' stamp: 'Pablo 3/29/2013 19:15'!
tuRefresco
	"Devuelve la tasa de refresco del SmartTv"
	
	^135! !

Producto subclass: #TV
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PruebaPablo'!

!TV class methodsFor: 'as yet unclassified' stamp: 'Pablo 4/6/2013 16:08'!
teFabricoConTecnologia: unaTecnologia conTamanio: unTamanio conPPP: unPPP 
	"Crea un objeto de la clase TV" 

	| pantalla |
	pantalla := unaTecnologia  fabricarTV .
	pantalla inicializarConTamanio: unTamanio conPPP: unPPP .
	^pantalla! !

!TV methodsFor: 'as yet unclassified' stamp: 'Pablo 3/29/2013 19:14'!
tuRefresco
	"Devuelve la tasa de refresco del TV"
	
	^90! !

Object subclass: #TecnologiaStrategy
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PruebaPablo'!

!TecnologiaStrategy commentStamp: '<historical>' prior: 0!
TecnologiaStrategy es una clase abstracta. Se est utilizando el patrn Strategy!

TecnologiaStrategy subclass: #CRT
	uses: Analogico + FabricaDePantallas - {#fabricarSmartTV}
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PruebaPablo'!

CRT class
	uses: Analogico classTrait + FabricaDePantallas classTrait
	instanceVariableNames: ''!

!CRT methodsFor: 'as yet unclassified' stamp: 'Pablo 3/29/2013 18:07'!
tuConsumo: tamanio
	"Devuelve el consumo en watts por hora."

	^ ( 5 * tamanio )! !

TecnologiaStrategy subclass: #LCD
	uses: Digital + FabricaDePantallas - {#fabricarSmartTV}
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PruebaPablo'!

LCD class
	uses: Digital classTrait + FabricaDePantallas classTrait
	instanceVariableNames: ''!

!LCD methodsFor: 'as yet unclassified' stamp: 'Pablo 3/29/2013 18:25'!
tuConsumo: tamanio
	"Devuelve el consumo en watts por hora."

	^ ( 4 * tamanio )! !

!LCD methodsFor: 'as yet unclassified' stamp: 'Braian 4/14/2013 00:52'!
tuDefinicionMaxima: aparato
	"Devuelve la definicin mxima de un dispositivo con tecnologa digital. "

	^( aparato cualesSonTusPPP *  ( ( ( aparato  tamanio  ) raisedTo: 2 )  / 2 )  sqrt )! !

TecnologiaStrategy subclass: #LED
	uses: Digital + FabricaDePantallas
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PruebaPablo'!

LED class
	uses: Digital classTrait + FabricaDePantallas classTrait
	instanceVariableNames: ''!

!LED methodsFor: 'as yet unclassified' stamp: 'Pablo 3/29/2013 18:26'!
tuConsumo: tamanio
	"Devuelve el consumo en watts por hora."

	^ ( 1 * tamanio )! !

!LED methodsFor: 'as yet unclassified' stamp: 'Braian 4/14/2013 00:52'!
tuDefinicionMaxima: aparato
	"Devuelve la definicin mxima de un dispositivo con tecnologa digital. "

	^( aparato cualesSonTusPPP *  ( ( ( aparato  tamanio  ) raisedTo: 2 )  / 2 )  sqrt )! !

!TecnologiaStrategy methodsFor: 'as yet unclassified' stamp: 'Pablo 4/9/2013 23:19'!
tuConsumo: tamanio 

	self subclassResponsibility ! !
